"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ApiSnapshotTag = "[APISnap]";
function parse(response) {
    return __awaiter(this, void 0, void 0, function () {
        var res, _a, _b, _c, _d;
        return __generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    if (!(response.config &&
                        response.config.method &&
                        response.config.url &&
                        response.status &&
                        response.data)) return [3 /*break*/, 1];
                    //response is done with axios library (https://www.npmjs.com/package/axios)
                    return [2 /*return*/, {
                            httpMethod: response.config.method.toLowerCase(),
                            url: response.config.url,
                            mock: { statusCode: response.status, body: response.data }
                        }];
                case 1:
                    if (!(response.response && response.opts && response.opts.method)) return [3 /*break*/, 4];
                    return [4 /*yield*/, response.response];
                case 2:
                    res = _e.sent();
                    _a = {
                        httpMethod: response.opts.method.toLowerCase(),
                        url: res.url
                    };
                    _b = { statusCode: res.status };
                    return [4 /*yield*/, response.text];
                case 3: return [2 /*return*/, (_a.mock = (_b.body = _e.sent(), _b),
                        _a)];
                case 4:
                    if (!(response.url && response.status)) return [3 /*break*/, 6];
                    _c = {
                        httpMethod: response.method || "get",
                        url: response.url
                    };
                    _d = { statusCode: response.status };
                    return [4 /*yield*/, response.text()];
                case 5: 
                //response is done with fetch library (https://www.npmjs.com/package/node-fetch)
                return [2 /*return*/, (_c.mock = (_d.body = _e.sent(), _d),
                        _c)];
                case 6:
                    if (response.status && response.req && response.req.method) {
                        //response is done with chai library (https://www.google.it.on.your/own)
                        return [2 /*return*/, {
                                httpMethod: response.req.method.toLowerCase(),
                                url: response.req.path,
                                mock: { statusCode: response.status, body: response.body }
                            }];
                    }
                    else {
                        throw Error("The response is not supported, we're supporting only the usage of:\n            axios(https://www.npmjs.com/package/axios), r2(https://github.com/mikeal/r2) &\n            fetch(https://www.npmjs.com/package/node-fetch)\n            You can submit an issue on https://github.com/Iqoqo/mockshot/issues to add support for another library");
                    }
                    _e.label = 7;
                case 7: return [2 /*return*/];
            }
        });
    });
}
function toMatchApiMock(response, mockName) {
    return __awaiter(this, void 0, void 0, function () {
        var parsedResponse, err_1, snapshot, snapshotTag;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, parse(response)];
                case 1:
                    parsedResponse = _a.sent();
                    return [3 /*break*/, 3];
                case 2:
                    err_1 = _a.sent();
                    return [2 /*return*/, { pass: false, message: function () { return err_1.message; } }];
                case 3:
                    snapshot = __assign({ mockName: mockName }, parsedResponse);
                    snapshotTag = "[mockshot] " + exports.ApiSnapshotTag + " [" + parsedResponse.httpMethod + " " + parsedResponse.url + " " + mockName + "]";
                    return [2 /*return*/, {
                            pass: undefined === expect(snapshot).toMatchSnapshot(snapshotTag),
                            message: function () { return "expected " + snapshot + " to match tag " + snapshotTag; }
                        }];
            }
        });
    });
}
exports.toMatchApiMock = toMatchApiMock;
//# sourceMappingURL=ApiMockMatcher.js.map