"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var lodash_1 = require("lodash");
exports.ClassSnapshotTag = "[ClassSnap]";
function toMatchClassMock(mock, className, methodName, mockName, ignoredKeyPaths) {
    var snapshotTag = "[mockshot] " + exports.ClassSnapshotTag + " [[" + className + " " + methodName + " " + mockName + "]]";
    var snapshotName = this.currentTestName + ": " + snapshotTag + " 1";
    var currentSnapshot = this.snapshotState._snapshotData[snapshotName];
    if (ignoredKeyPaths && currentSnapshot) {
        var parsedSnapshot_1 = JSON.parse(currentSnapshot);
        ignoredKeyPaths.forEach(function (keyPath) {
            var val = lodash_1.get(parsedSnapshot_1.mock, keyPath);
            var target = lodash_1.get(mock, keyPath);
            if (val &&
                target &&
                (typeof val === typeof target || isTimestamp(target))) {
                lodash_1.set(mock, keyPath, val);
            }
        });
    }
    var snapshot = { className: className, methodName: methodName, mockName: mockName, mock: mock };
    return {
        pass: undefined === expect(snapshot).toMatchSnapshot(snapshotTag),
        message: function () { return "expected " + snapshot + " to match tag " + snapshotTag; }
    };
}
exports.toMatchClassMock = toMatchClassMock;
var isTimestamp = function (target) { return "object" === typeof target && Date.parse(target); };
//# sourceMappingURL=ClassMockMatcher.js.map